> ## Documentation Index
> Fetch the complete documentation index at: https://docs.cerca.dev/llms.txt
> Use this file to discover all available pages before exploring further.

# List thread messages

> List a bounded page of transcript messages for a thread, newest first. Use the returned `cursor` to page older messages.



## OpenAPI

````yaml https://app.stainless.com/api/spec/documented/cerca/openapi.documented.yml get /agents/{agentId}/threads/{threadId}/messages
openapi: 3.1.0
info:
  description: API-key accessible routes for Cerca agents.
  title: Cerca API
  version: 0.0.0
servers:
  - url: https://api.cerca.dev
security:
  - bearerAuth: []
paths:
  /agents/{agentId}/threads/{threadId}/messages:
    get:
      tags:
        - Threads
      summary: List thread messages
      description: >-
        List a bounded page of transcript messages for a thread, newest first.
        Use the returned `cursor` to page older messages.
      parameters:
        - schema:
            type: string
            minLength: 1
            example: agent_abc123
          required: true
          in: path
          name: agentId
        - schema:
            type: string
            minLength: 1
            example: thread_abc123
          required: true
          in: path
          name: threadId
        - schema:
            type: string
            pattern: ^\d+$
            description: Cursor returned by a previous thread messages response.
            example: '42'
          required: false
          description: Cursor returned by a previous thread messages response.
          name: cursor
          in: query
        - schema:
            type: string
            description: Optional fleet id for index-backed authorization.
          required: false
          description: Optional fleet id for index-backed authorization.
          name: fleetId
          in: query
        - schema:
            type: string
            pattern: ^\d+$
            description: Maximum number of messages to include, capped at 500.
            example: '100'
          required: false
          description: Maximum number of messages to include, capped at 500.
          name: limit
          in: query
      responses:
        '200':
          description: Thread messages page.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ThreadMessagesPage'
        '400':
          description: Invalid runtime request.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '401':
          description: Authentication required.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '403':
          description: >-
            Access denied or non-transient quota exceeded. Limit errors include
            a stable code field.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '404':
          description: Runtime resource not found.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '409':
          description: Thread lifecycle conflict.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '429':
          description: >-
            Transient capacity limit exceeded. Limit errors include a stable
            code field.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '500':
          description: Thread lifecycle operation failed.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        '503':
          description: Required runtime dependency unavailable.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
        default:
          description: Runtime error response.
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/ErrorResponse'
      security:
        - bearerAuth: []
      x-codeSamples:
        - lang: JavaScript
          source: >-
            import Cerca from '@cerca-dev/sdk';


            const client = new Cerca({
              apiKey: process.env['CERCA_API_KEY'], // This is the default and can be omitted
            });


            // Automatically fetches more pages as needed.

            for await (const message of
            client.threads.listMessages('agent_abc123', 'thread_abc123')) {
              console.log(message.content);
            }
        - lang: Python
          source: |-
            import os
            from cerca import Cerca

            client = Cerca(
                api_key=os.environ.get("CERCA_API_KEY"),  # This is the default and can be omitted
            )
            page = client.threads.list_messages(
                agent_id="agent_abc123",
                thread_id="thread_abc123",
            )
            page = page.messages[0]
            print(page.content)
        - lang: Go
          source: "package main\n\nimport (\n\t\"context\"\n\t\"fmt\"\n\n\t\"github.com/matrices/cerca-go\"\n\t\"github.com/matrices/cerca-go/option\"\n)\n\nfunc main() {\n\tclient := cercago.NewClient(\n\t\toption.WithAPIKey(\"My API Key\"),\n\t)\n\tpage, err := client.Threads.ListMessages(\n\t\tcontext.TODO(),\n\t\t\"agent_abc123\",\n\t\t\"thread_abc123\",\n\t\tcercago.ThreadListMessagesParams{},\n\t)\n\tif err != nil {\n\t\tpanic(err.Error())\n\t}\n\tfmt.Printf(\"%+v\\n\", page)\n}\n"
        - lang: Ruby
          source: |-
            require "cerca"

            cerca = Cerca::Client.new(api_key: "My API Key")

            page = cerca.threads.list_messages("agent_abc123", "thread_abc123")

            puts(page)
        - lang: CLI
          source: |-
            cerca threads list-messages \
              --api-key 'My API Key' \
              --agent-id agent_abc123 \
              --thread-id thread_abc123
components:
  schemas:
    ThreadMessagesPage:
      type: object
      properties:
        cursor:
          type:
            - string
            - 'null'
        hasMore:
          type: boolean
        messages:
          type: array
          items:
            $ref: '#/components/schemas/ThreadMessage'
      required:
        - cursor
        - hasMore
        - messages
    ErrorResponse:
      type: object
      properties:
        error:
          type: string
        code:
          type: string
          description: Stable machine-readable error code when the API can provide one.
          example: MONTHLY_TOKEN_BUDGET_EXCEEDED
      required:
        - error
    ThreadMessage:
      type: object
      properties:
        content:
          type: array
          items:
            $ref: '#/components/schemas/ContentBlock'
        createdAt:
          type: string
        role:
          type: string
          enum:
            - user
            - assistant
        seq:
          type: number
      required:
        - content
        - createdAt
        - role
        - seq
    ContentBlock:
      oneOf:
        - $ref: '#/components/schemas/TextContentBlock'
          title: TextContentBlock
          x-stainless-variantName: TextContentBlock
        - $ref: '#/components/schemas/ToolUseContentBlock'
          title: ToolUseContentBlock
          x-stainless-variantName: ToolUseContentBlock
        - $ref: '#/components/schemas/ToolResultContentBlock'
          title: ToolResultContentBlock
          x-stainless-variantName: ToolResultContentBlock
        - $ref: '#/components/schemas/ServerToolUseContentBlock'
          title: ServerToolUseContentBlock
          x-stainless-variantName: ServerToolUseContentBlock
        - $ref: '#/components/schemas/WebSearchToolResultContentBlock'
          title: WebSearchToolResultContentBlock
          x-stainless-variantName: WebSearchToolResultContentBlock
      discriminator:
        propertyName: type
      description: >-
        Message content block. The `type` field distinguishes text, tool use,
        tool result, server tool use, and web search result blocks.
      example:
        text: Hello
        type: text
    TextContentBlock:
      type: object
      properties:
        providerMetadata:
          $ref: '#/components/schemas/ProviderMetadata'
        text:
          type: string
        type:
          type: string
          enum:
            - text
          x-stainless-const: true
      required:
        - text
        - type
    ToolUseContentBlock:
      type: object
      properties:
        id:
          type: string
        input:
          $ref: '#/components/schemas/JsonValue'
        name:
          $ref: '#/components/schemas/RuntimeToolName'
        providerMetadata:
          $ref: '#/components/schemas/ProviderMetadata'
        type:
          type: string
          enum:
            - tool_use
          x-stainless-const: true
      required:
        - id
        - input
        - name
        - type
    ToolResultContentBlock:
      type: object
      properties:
        content:
          type: string
        deniedByUser:
          type: boolean
        isError:
          type: boolean
        providerMetadata:
          $ref: '#/components/schemas/ProviderMetadata'
        toolUseId:
          type: string
        type:
          type: string
          enum:
            - tool_result
          x-stainless-const: true
      required:
        - content
        - isError
        - toolUseId
        - type
    ServerToolUseContentBlock:
      type: object
      properties:
        id:
          type: string
        input:
          $ref: '#/components/schemas/JsonValue'
        name:
          type: string
        providerMetadata:
          $ref: '#/components/schemas/ProviderMetadata'
        type:
          type: string
          enum:
            - server_tool_use
          x-stainless-const: true
      required:
        - id
        - input
        - name
        - type
    WebSearchToolResultContentBlock:
      type: object
      properties:
        content:
          x-stainless-any: true
          description: >-
            Web search result payload. The runtime returns either an array of
            web search results or an error object.
        toolUseId:
          type: string
        type:
          type: string
          enum:
            - web_search_tool_result
          x-stainless-const: true
      required:
        - content
        - toolUseId
        - type
    ProviderMetadata:
      type: object
      additionalProperties:
        $ref: '#/components/schemas/ProviderMetadataEntry'
    JsonValue:
      description: >-
        Any JSON value. Generated SDKs may expose this value boundary as unknown
        or Any.
      x-stainless-any: true
    RuntimeToolName:
      type: string
      enum:
        - get_time
        - sub_thread
        - wait
        - tool.call
        - tool.discover
        - artifact.read
        - agent.threads.list
        - agent.threads.get
        - agent.approvals.cancel
        - agent.approvals.grant_thread
        - agent.approvals.grant_agent
        - agent.create
        - agent.approvals.update
        - tool.connect
        - sandbox.exec
        - sandbox.read
        - sandbox.write_file
        - sandbox.read_file
        - sandbox.spawn
        - sandbox.stdin
        - sandbox.session_read
        - sandbox.kill
        - sandbox.list_sessions
        - sandbox.sync_artifact
        - memory.read
        - memory.list
        - memory.search
        - memory.write
        - memory.delete
        - db.query
        - web.search
        - web.fetch
        - agent.schedule.list
        - agent.schedule.create
        - agent.schedule.update
        - agent.schedule.delete
        - agent.schedule.trigger
    ProviderMetadataEntry:
      type: object
      additionalProperties:
        type: string
      description: Provider-specific metadata for a message content block.
  securitySchemes:
    bearerAuth:
      bearerFormat: Cerca API key
      scheme: bearer
      type: http

````